/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File z80.h - defines the processor and its registers.
 *              Also declares some common functions.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<sys/param.h>

#define True 1
#define False 0


#define SAM_CYCLES  69888*(6./3.5)     /* estimated clock cycles per frame */

#define Z80_none  0
#define Z80_quit  1
#define Z80_nmi   2
#define Z80_reset 3

/* Make sure that the unsigned short type on this machine is 16 bits
 * or the moon will explode */
typedef unsigned short uns16;
typedef unsigned char  uns8;
typedef signed short   sgn16;
typedef signed char    sgn8;
typedef unsigned int   uns32;
typedef signed int     sgn32;



#define af ((a<<8)|f)
#define bc ((b<<8)|c)
#define de ((d<<8)|e)
#define hl ((h<<8)|l)
#define bc_prime ((b1<<8)|c1)
#define af_prime ((a1<<8)|f1)
#define de_prime ((d1<<8)|e1)
#define hl_prime ((h1<<8)|l1)

/* Constants used to bit-mask the F register */
#define F_CARRY		0x01
#define F_NADD		0x02	/* For BCD. */
#define F_PARITY	0x04
#define F_OVERFLOW	0x04
#define F_HCARRY	0x10	/* For BCD. */
#define F_ZERO		0x40
#define F_NEG		0x80

void init_ports(void);
void emulator_main_loop(void);
